#define F_CPU 4000000UL	// Baby Orangutan frequency (20MHz)
#include <avr/io.h>
#include <util/delay.h>
#include <avr/pgmspace.h>
#include <stdlib.h>			// itoa function
#include <string.h>
#include "lcd.c"
#include "therm_ds18b20.c"

char buffer[16];
void read_temperature(char *buffer);

int main( void ) {
	

	lcd_init();  //Inicializace LCD 
    lcd_clrscr();                       //vymazani LCD 


	DDRD |= 1 << PD1;			// set LED pin PD1 to output


	while ( 1 ) {

		
		lcd_clrscr(); 
		read_temperature(buffer);





		_delay_ms(3000);
		
	}
	return 0;
}


void read_temperature(char *buffer){
			uint8_t temperature[2];
			char pom [3];
			//**Reset, skip ROM and start temperature conversion
			therm_reset();
			therm_write_byte(SKIP_ROM);
			therm_write_byte(CONVERT_T);

			//**Wait until conversion is complete
			while(!therm_read_bit()); //DS18B20 send 1 for conversion is done

			//**Reset, skip ROM and send command to read Scratchpad
			therm_reset();
			therm_write_byte(SKIP_ROM);
			therm_write_byte(READ_SCRAT);

			//**Read Scratchpad (only 2 first bytes)
			
			temperature[0]=therm_read_byte();        //low byte
			temperature[1]=therm_read_byte();        //high byte
			therm_reset();
			
			sprintf(pom,"%d",temperature[0]);
			lcd_string(pom);
			sprintf(pom,"%d",temperature[1]);
			lcd_string(pom);

			//**conversion 2 byte to digit and decimal
			uint8_t digit;
			uint16_t decimal;

			digit = (temperature[1]<<4)&0xf0;        //form 2 bytes to byte for conversion
			digit |= (temperature[0]&0xf0)>>4;

			decimal = (temperature[0]&0xf)*625;        //625 create whole number (over 8b therefore uint16_t)
			decimal/=100;    //only 2 decimal place (1000 - one decimal place)

}
